////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                //
// BeDVI                                                                                                          //
// by Achim Blumensath                                                                                            //
// blume@corona.oche.de                                                                                           //
//                                                                                                                //
// This program is free software! It may be distributed according to the GNU Public License (see COPYING).        //
//                                                                                                                //
// $Id: BeDVI.h,v 1.3 1996/12/26 15:34:26 achim Exp achim $
//                                                                                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef VIEWDVI_H
#define VIEWDVI_H

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef DEFINES_H
#include "defines.h"
#endif
#ifndef DVI_H
#include "DVI.h"
#endif

class BFile;
class DisplayInfo;
class DVIView;
class ViewWindow;

#define VERSION "V1.2"

// Messages:

static const u_long MsgOpenPanel    = MAKE_ID('o', 'p', 'n', 'l');
static const u_long MsgOpenFile     = MAKE_ID('o', 'p', 'e', 'n');
static const u_long MsgAntiAliasing = MAKE_ID('g', 'r', 'e', 'y');
static const u_long MsgBorderLine   = MAKE_ID('b', 'o', 'r', 'd');
static const u_long MsgMeasureWin   = MAKE_ID('m', 'w', 'i', 'n');
static const u_long MsgSearch       = MAKE_ID('f', 'i', 'n', 'd');
static const u_long MsgNext         = MAKE_ID('n', 'e', 'x', 't');
static const u_long MsgPrev         = MAKE_ID('p', 'r', 'e', 'v');
static const u_long MsgFirst        = MAKE_ID('f', 'i', 'r', 's');
static const u_long MsgLast         = MAKE_ID('l', 'a', 's', 't');
static const u_long MsgSaveSettings = MAKE_ID('s', 'v', 's', 't');
static const u_long MsgPage         = MAKE_ID('p', 'a', 'g', 'e');

class ViewApplication: public BApplication
{
  private:
    DisplayInfo DspInfo;
    ViewWindow  *win;
    DVIView     *vw;
//    BMessage    *FilePanelMsg;

  public:
    BRect WindowBounds;
    bool  AntiAliasedDisplay;

            ViewApplication();
    virtual ~ViewApplication();

    virtual void ArgvReceived(int argc, char **argv);
    virtual void RefsReceived(BMessage *msg);
    virtual void AboutRequested();
//    virtual void FilePanelClosed(BMessage *msg);
    virtual void MessageReceived(BMessage *msg);

    void LaunchFilePanel();
    void OpenFile(record_ref File);
    void DisplayError(char *msg);
    void SetResolution(u_int PixelsPerInch, u_int ShrinkFactor);
    void ToggleAntiAliasing();
    void UpdateMenus();

    bool Ok()
    {
      return win != NULL && vw != NULL;
    }
};

bool       InitAppMenu();
ViewWindow *InitWindow();
void       SetSleepCursor();
void       SetNormalCursor();

u_long ReadInt(BFile &f, size_t Size);
long   ReadSInt(BFile &f, size_t Size);

#endif
