////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                //
// BeDVI                                                                                                          //
// by Achim Blumensath                                                                                            //
// blume@corona.oche.de                                                                                           //
//                                                                                                                //
// This program is free software! It may be distributed according to the GNU Public License (see COPYING).        //
//                                                                                                                //
// $Id: FontList.h,v 1.3 1996/12/26 15:34:26 achim Exp achim $
//                                                                                                                //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef FONTLIST_H
#define FONTLIST_H

#include <KernelKit.h>
#ifndef DEFINES_H
#include "defines.h"
#endif
#ifndef LIST_H
#include "list.h"
#endif

class DVI;
class Font;

class FontTable
{
  public:
    sem_id TableSem;
    Font   **Table;
    u_long TableLen;

    FontTable();
    ~FontTable();

    Font *LoadFont(DVI *doc, BFile &f, u_char Command);
    bool Resize(u_long len);
    void FreeFonts();

    bool Ok()
    {
      return (TableSem >= B_NO_ERROR) && (Table != NULL);
    }
};

class FontList
{
  private:
    sem_id ListLock;
    List   Fonts;

  public:
    FontList();
    ~FontList();

    Font *LoadFont(DVI *doc, const char *Name, float Size, long ChkSum, int MagStepVal, double DimConvert);
    void FreeFont(Font *f);
    void FreeAll();
    void FreeUnusedFonts();
    void FlushShrinkedGlyphes();
};

extern FontList FontData;

#endif